
kPlayer = {}

function kPlayer.Getilvl()
    local avgItemLevel, avgItemLevelEquipped, avgItemLevelPvp = GetAverageItemLevel()
    return math.floor(avgItemLevelEquipped)
end

function kPlayer.GetFaction()
    local englishFaction, localizedFaction = UnitFactionGroup("player")
    return englishFaction
end

function kPlayer.GetRecord()
    local currentWeekBestLevel, weeklyRewardLevel, nextDifficultyWeeklyRewardLevel, nextBestLevel = C_MythicPlus.GetWeeklyChestRewardLevel()
    return (currentWeekBestLevel or 0)
end

function kPlayer.ColoredName()
    local className, classFilename, classID = UnitClass("player")
    local rPerc, gPerc, bPerc, argbHex = GetClassColor(classFilename)
    local name = UnitName("player")
    return "|c"..argbHex..name.."|r"
end

function kPlayer.ResetAllData()
    local resetTime = nil
    if GetCurrentRegion() == 3 then -- if in EU region
        resetTime = GetServerTime()- (GetServerTime() - 1500447600)%604800
        --week count for Astralkeys
        kPlayer.AstralWeekCount = math.floor((GetServerTime() - 1500447600) / 604800) 
    else -- if not EU region
        resetTime = GetServerTime()- (GetServerTime() - 1500390000)%604800
        --week count for Astralkeys
        kPlayer.AstralWeekCount = math.floor((GetServerTime() - 1500390000) / 604800) 
      --  resetTime = 1500390000
    end
    if WeekKeysDB.ResetTime == nil then
        WeekKeysDB.ResetTime = resetTime
        return
    elseif WeekKeysDB.ResetTime ~= resetTime then
        for k,v in pairs(WeekKeysDB.Character) do
            if v.record > 0 then
                v.reward = true
            end
            v.keyID = nil
            v.record = 0
        end
        WeekKeysDB.Guild = nil
        WeekKeysDB.ResetTime = resetTime
    end

end

function kPlayer.GetMessage(prefix, msg, channel, sender)
    local senderName, senderRealm = strsplit("-",sender)
    if senderName == kPlayer.name and senderRealm == kPlayer.realm:gsub(" ","") then
        return
    end
    if prefix == "WeekKeys" and channel == "GUILD" then
        local command, text = strsplit(" ",msg)
        if msg == "request" then
            for a,b in pairs(WeekKeysDB.Character) do
                --C_ChatInfo.SendAddonMessage
                --kPlayer.GetMessage("WeekKeys","update www:hola:\124cffff0000www:123:11:::Alliancce","GUILD","s-s")
                --command_name:realm:colored:ilvl:record:keyid:keylevel:faction
                --C_ChatInfo.SendAddonMessage("WeekKeys","update_kkk:hydjal:cffff0000kkk:123:15:::Alliancce","GUILD")
                if b.faction == kPlayer.faction then
                    C_ChatInfo.SendAddonMessage("WeekKeys", "update "..b.name..":"..b.realm..":"..b.colored..":"..b.ilvl..":"..b.record..":"..(b.keyID or "")..":"..(b.keyLevel or "")..":"..b.faction, "GUILD")
                end
            end
        elseif command == "update" then
            local name,realm,colored,ilvl,record,key,keylevel,faction = strsplit(":",text)
            WeekKeysDB.Guild = WeekKeysDB.Guild or {}
            WeekKeys.db.add(WeekKeysDB.Guild,name,realm,colored,tonumber(ilvl),tonumber(record),tonumber(key),tonumber(keylevel),faction,sender)
        end
    elseif prefix == "WeekKeys" and channel == "PARTY" then
        if msg == "request" then
            for a,b in pairs(WeekKeysDB.Character) do
                --C_ChatInfo.SendAddonMessage
                --kPlayer.GetMessage("WeekKeys","update www:hola:\124cffff0000www:123:11:::Alliancce","GUILD","s-s")
                --command_name:realm:colored:ilvl:record:keyid:keylevel:faction
                --C_ChatInfo.SendAddonMessage("WeekKeys","update_kkk:hydjal:cffff0000kkk:123:15:::Alliancce","GUILD")
                if b.faction == kPlayer.faction then
                    C_ChatInfo.SendAddonMessage("WeekKeys", "update "..b.name..":"..b.realm..":"..b.colored..":"..b.ilvl..":"..b.record..":"..(b.keyID or "")..":"..(b.keyLevel or "")..":"..b.faction, "party")
                end
            end
        elseif msg:find("update ") then
            local command ,text = strsplit(" ",msg)
            local name,realm,colored,ilvl,record,key,keylevel,faction = strsplit(":",text)
            WeekKeys.db.add(WeekFrame.pIDs,name,realm,colored,ilvl,record,key,keylevel,faction,sender)
           --[[ if WeekFrame.pIDs ~= nil then
                for a,b in pairs(WeekFrame.pIDs) do --renew info in DB
                    if b.name == name and b.realm == realm then
                        b.ilvl = tonumber(ilvl)
                        b.record = tonumber(record)
                        if key ~= "" then
                            b.keyID = tonumber(key)
                            b.keyLevel = tonumber(keylevel)
                        end
                        b.sender = sender
                        return
                    end
                end
                -- if can't find in DB, we add new character
                local table = {}
                table.name = name
                table.realm = realm
                table.colored = colored
                table.ilvl = tonumber(ilvl)
                if key ~= "" then
                    table.keyID = tonumber(key)
                    table.keyLevel = tonumber(keylevel)
                end
                table.faction = faction
                table.sender = sender
                tinsert(WeekFrame.pIDs,table)
            else
                WeekKeysDB.Guild = {}
                local table = {}
                table.name = name
                table.realm = realm
                table.colored = colored
                table.ilvl = tonumber(ilvl)
                if key ~= "" then
                    table.keyID = tonumber(key)
                    table.keyLevel = tonumber(keylevel)
                end
                table.faction = faction
                table.sender = sender
                tinsert(WeekKeysDB.Guild,table)
            end]]
        end
    elseif prefix == "AstralKeys" and channel == "GUILD" then
        local command, msgData = strsplit(" ",msg)
        if command == "updateV8" then
            WeekKeysDB.Guild = WeekKeysDB.Guild or {}
            local char, class, key, keylevel, rrecord, week, rfaction = strsplit(":",msgData) -- split AstralKeys data
            local cname, crealm = strsplit("-",char) -- split name and realm
            if tonumber(week) ~= kPlayer.AstralWeekCount then
                return
            end
            for id,data in pairs(WeekKeysDB.Guild) do
                if data.name == cname and data.realm == crealm then
                    data.keyID = tonumber(key)
                    data.keyLevel = tonumber(keylevel)
                    data.record = tonumber(rrecord)
                    return
                end
            end

            local faction = nil
            if tonumber(rfaction) == 0 then
                faction = "Alliance"
            else
                faction = "Horde"
            end
            local r,g,b,hex = GetClassColor(class)
            local table = {
                ["name"] = cname,
                ["colored"] = "|c"..hex..cname,
                ["realm"] = crealm,
                ["keyID"] = tonumber(key),
                ["keyLevel"] = tonumber(keylevel),
                ["record"] = tonumber(rrecord),
                ["faction"] = faction
            }
            tinsert(WeekKeysDB.Guild, table)
        elseif command == "updateWeekly" then
            if WeekKeysDB.Guild == nil then
                return
            end
            local name, realm = strsplit("-", sender)
            for id, data in pairs(WeekKeysDB.Guild) do
                if data.name == name and data.realm == realm then
                    data.record = tonumber(msgData)
                    return
                end
            end
        end
    elseif prefix == "AngryKeystones" then
        msg = msg:gsub("Schedule|","")
        local arg1, arg2 = msg:match("^(%d+):(%d+)$")
       -- print(arg1, "<=>",arg2, "<=>",msg)
        if arg1 and arg2 then
            local keystoneMapID = arg1 and tonumber(arg1)
            local keystoneLevel = arg2 and tonumber(arg2)
            local checked = false
            if WeekFrame.pIDs then
                for i = 1, #WeekFrame.pIDs do
                    if WeekFrame.pIDs[i].name == senderName and WeekFrame.pIDs[i].realm == senderRealm then
                        WeekFrame.pIDs[i].keyID = keystoneMapID
                        WeekFrame.pIDs[i].keylevel = keystoneLevel
                       -- print("update")
                        checked = true
                    end
                end
                if not checked then
                    --print("create")
                    tinsert(WeekFrame.pIDs,{
                        ["name"] = senderName,
                        ["realm"] = senderRealm,
                        ["keyID"] = keystoneMapID,
                        ["keyLevel"] = keystoneLevel
                    })
                end
            else
                WeekFrame.pIDs = WeekFrame.pIDs or {}
                
                tinsert(WeekFrame.pIDs,{
                    ["name"] = senderName,
                    ["realm"] = senderRealm,
                    ["keyID"] = keystoneMapID,
                    ["keylevel"] = keystoneLevel
                })
            end
        end
    end

end
function kPlayer.BN_Message(prefix, text, senderID)
    if prefix == "WeekKeys" then
        if text == "request" and BNConnected() then
            for k,v in pairs(WeekKeysDB.Character) do
                local message = "update "..v.name..":"..v.realm..":"..v.colored..":"..v.ilvl..":"..v.record..":"..(v.keyID or "")..":"..(v.keyLevel or "")..":"..v.faction
                BNSendGameData(senderID, "WeekKeys", message)
            end
        elseif text:find("update ") then
            WeekKeysDB.friends = WeekKeysDB.friend or {}
            local _, data = strsplit(" ",text)
            local name,realm,colored,ilvl,record,keyid,keylevel,faction = strsplit(":",data)
            local frinedIndex = BNGetFriendIndex(senderID)
            local friend = C_BattleNet.GetFriendAccountInfo(frinedIndex)
            local sender = friend.battleTag
            WeekKeys.db.add(WeekKeysDB.friends,name,realm,colored,ilvl,record,keyid,keylevel,faction,sender)
        end
    end
end

function kPlayer:GetAllData()
    self.keyID = C_MythicPlus.GetOwnedKeystoneChallengeMapID()
    self.keyLevel = C_MythicPlus.GetOwnedKeystoneLevel()
    self.name = UnitName("player")
    self.realm = GetRealmName()
    self.ilvl = self.Getilvl()
    self.faction = self.GetFaction()
    self.record = self.GetRecord()
    self.colored = self.ColoredName()

end

function kPlayer:GetKeyData()
    self.keyID = C_MythicPlus.GetOwnedKeystoneChallengeMapID()
    self.keyLevel = C_MythicPlus.GetOwnedKeystoneLevel()
    self.ilvl = self.Getilvl()
    self.record = self.GetRecord()
end

function kPlayer:GetID()
    WeekKeysDB = WeekKeysDB or {}
    WeekKeysDB.Character = WeekKeysDB.Character or {}
    if #WeekKeysDB.Character ~= 0 then
        -- try to find character in database
        for i,_ in pairs(WeekKeysDB.Character) do
            if WeekKeysDB.Character[i].name == self.name and WeekKeysDB.Character[i].realm == self.realm then
                self.ID = i
                return
            end
        end
        -- find free id
        for i = 1,100 do
            if WeekKeysDB.Character[i] == nil then
                self.ID = i
                return
            end
        end
       -- self.ID = #WeekKeysDB.Character + 1
    else
        self.ID = 1
    end
end


function kPlayer:Save()
    local id = self.ID
    WeekKeysDB = WeekKeysDB or {}
    WeekKeysDB.Character = WeekKeysDB.Character or {}
    if UnitLevel("player") == 120 then
        WeekKeysDB.Character[id] = WeekKeysDB.Character[id] or {}
        WeekKeysDB.Character[id].keyID = self.keyID
        WeekKeysDB.Character[id].keyLevel = self.keyLevel
        WeekKeysDB.Character[id].name = self.name
        WeekKeysDB.Character[id].realm = self.realm
        WeekKeysDB.Character[id].ilvl = self.ilvl
        WeekKeysDB.Character[id].faction = self.faction
        WeekKeysDB.Character[id].record = self.record
        WeekKeysDB.Character[id].colored = self.colored
    end
end

